unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ComCtrls, ExtCtrls,
  UnitData, UnitFunc, UnitZumenTitle, UnitZumenPaper, UnitZumenLayer,
  UnitZumenColor, UnitZumenLtype, UnitZumenWidth, UnitZumenFont,
  UnitDataGraph, UnitGraph ;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    PaintBox1: TPaintBox;
    RadioGroup1: TRadioGroup;
    Button8: TButton;
    Label1: TLabel;
    Label2: TLabel;
    TreeView1: TTreeView;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// N
procedure TForm1.FormShow(Sender: TObject);
begin
   CData := TDataClass.Create ;
   gp := TGraphClass.Create ;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   gp.Free;
   CData.Free;
end;

// [}ʏb}ʕ\藓̐ݒ]
procedure TForm1.Button1Click(Sender: TObject);
begin
   FmZumenTitle.P_CData := CData ;
   FmZumenTitle.ShowModal ;
   if (FmZumenTitle.P_OK) then begin
      // OK
   end;
end;

// [}ʍ\bp̐ݒ]
procedure TForm1.Button2Click(Sender: TObject);
begin
   FmZumenPaper.P_CData := CData ;
   FmZumenPaper.ShowModal ;
   if (FmZumenPaper.P_OK) then begin
      // OK
   end;
end;

// [}ʍ\bC̐ݒ]
procedure TForm1.Button3Click(Sender: TObject);
begin
   FmZumenLayer.P_CData := CData ;
   FmZumenLayer.ShowModal ;
end;

// [}ʍ\bF̐ݒ]
procedure TForm1.Button4Click(Sender: TObject);
begin
   FmZumenColor.P_CData := CData ;
   FmZumenColor.ShowModal ;
end;

// [}ʍ\b̐ݒ]
procedure TForm1.Button5Click(Sender: TObject);
begin
   FmZumenLtype.P_CData := CData ;
   FmZumenLtype.ShowModal ;
end;

// [}ʍ\b̐ݒ]
procedure TForm1.Button6Click(Sender: TObject);
begin
   FmZumenWidth.P_CData := CData ;
   FmZumenWidth.ShowModal ;
end;

// [}ʍ\btHg̐ݒ]
procedure TForm1.Button7Click(Sender: TObject);
begin
   FmZumenFont.P_CData := CData ;
   FmZumenFont.ShowModal ;
end;

// [`]
procedure TForm1.Button8Click(Sender: TObject);
var
   x1,y1,x2,y2,col,ltp,wid,i,j : integer ;
   mc : integer ;
   lx1,ly1,lx2,ly2 : double ;
   p : TTreeNode ;
   lx,ly : array of double ;
begin
   ScrX := PaintBox1.Width;
   ScrY := PaintBox1.Height;
   ZInit;   // ֘Aeϐ̏

   Z2D(x1,y1, 0.0,0.0);
   Z2D(x2,y2, CData.zp.x,CData.zp.y);

   Label1.Caption := 'F'+DStr(WndX1,2)+','+DStr(WndY1,2) ;
   Label2.Caption := 'EF'+DStr(WndX2,2)+','+DStr(WndY2,2) ;

   with CData do begin
      DataClearZukei ;  // }`f[^NA

      // tHg
      if (zFntN = 0) then begin
         AddFont('lr SVbN');
      end;
      // C
      if (zLayN = 0) then begin
         AddLayer('LAYER1',1,1,1,1,1);
      end;

      // }`
      dFzk  := nil;
      dFzkN := 0;
      for i:=0 to fDefN-1 do begin
         with fDef[i] do begin
            mFzk := nil;
         end;
      end;
      fDef  := nil;
      fDefN := 0;

      AddFZukeiDef('}`',1);      // XYWn
      AddFZukeiDef('}a',2);      // YXWn
      AddFZukeiDef('}O[vb',3);
      AddFZukeiDef('}ic',4);
      AddFZukeiDef('}id',4);

      AddDataFZukei('',0,'}`',200.0,250.0,30.0,1.5,1.2);
      AddDataFZukei('}`',0,'}O[vb',50.0,50.0,30,1.0,1.0);   // }O[v͈w肵Ă
      AddDataFZukei('}O[vb',0,'}ic',50.0,50.0,30,0.5,0.5);
      AddDataFZukei('',0,'}a',400.0,250.0,0.0,1.0,1.0);
      AddDataFZukei('}a',0,'}ic',10.0,20.0,0.0,2.0,1.0);
      AddDataFZukei('}a',0,'}id',10.0,20.0,0.0,1.0,2.0);
      AddDataFZukei('}ic',0,'}id',10.0,20.0,0.0,0.5,0.5);
      // AddDataFZukei('}id',0,'}ic',0.0,0.0,0.0,1.0,1.0);
      // ̂悤ȎwƖ[vԂɂȂ̂ŗv
   end;

   // \c[
   CData.MakeFZukeiTree ;
   TreeView1.Items.Clear ;
   TreeView1.Items.Add(nil,'p');
   for i:=0 to CData.zFztN-1 do begin
      j := Cdata.zFzt[i].par ;
      p := TreeView1.Items[j+1] ;
      TreeView1.Items.AddChild(p, Cdata.zFzt[i].name);
   end;

   gp.SetDisplayMode(RadioGroup1.ItemIndex);
   gp.G_Start(PaintBox1.Canvas);
   gp.G_Cls(clWhite);
   // pg`
   gp.G_SetPen(clBlue);
   gp.G_Line(x1,y1, x2,y1);
   gp.G_Line(x2,y1, x2,y2);
   gp.G_Line(x2,y2, x1,y2);
   gp.G_Line(x1,y2, x1,y1);

   // _}[JEf[^o^eXg
   //    \Lvf^pɒ
   col := 1 ;
   mc  := 1 ;
   for i:=1 to 20 do begin
      lx1 := i * 50 ;
      ly1 := 50.0 ;
      CData.AddDataTen('', 1,col,mc, lx1,ly1,0.0,15.0);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
      Inc(mc);
      if (mc > 7) then mc := 1 ;
   end;

   // _}[JEf[^o^eXg
   //    􉽗vf^}ȉ
   col := 1 ;
   mc  := 1 ;
   for i:=1 to 20 do begin
      lx1 := i * 50 ;
      ly1 := 50.0 ;
      CData.AddDataTen('}`', 1,col,mc, lx1,ly1,0.0,15.0);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
      Inc(mc);
      if (mc > 7) then mc := 1 ;
   end;

   // f[^o^eXg
   //    \Lvf^pɒ
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 50 do begin
      lx1 := i * 20 ;
      ly1 := 100.0 ;
      ly2 := 200.0 ;
      CData.AddDataLine('', 1,col,ltp,wid, lx1,ly1,lx1,ly2);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpN) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidN) then wid := 1 ;
   end;

   // f[^o^eXg
   //    􉽗vf^}ȉ
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 50 do begin
      lx1 := i * 20 ;
      ly1 := 100.0 ;
      ly2 := 200.0 ;
      CData.AddDataLine('}`', 1,col,ltp,wid, lx1,ly1,lx1,ly2);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpN) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidN) then wid := 1 ;
   end;

   // ܐf[^o^eXg
   //    \Lvf^pɒ
   SetLength(lx,5);
   SetLength(ly,5);
   lx1 := 0.0 ;
   ly1 := 0.0 ;
   lx2 := 200.0 ;
   ly2 := 150.0 ;
   lx[0] := lx1 ; ly[0] := ly1 ;
   lx[1] := lx2 ; ly[1] := ly1 ;
   lx[2] := lx2 ; ly[2] := ly2 ;
   lx[3] := lx1 ; ly[3] := ly2 ;
   lx[4] := lx1 ; ly[4] := ly1 ;
   CData.AddDataLines('', 1,2,2,1, 5, lx,ly);

   // ܐf[^o^eXg
   //    􉽗vf^}ȉ
   CData.AddDataLines('}`', 1,3,2,1, 5, lx,ly);

   for i:=0 to 4 do begin
      lx[i] := Random(100);
      ly[i] := Random(100);
   end;
   CData.AddDataLines('', 1,3,2,1, 5, lx,ly);

   lx := nil;
   ly := nil;

   // ~f[^o^eXg
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 10 do begin
      lx1 := i*5 ;
      CData.AddDataCircle('', 1,col,ltp,wid, 0.0,50.0,lx1);
      CData.AddDataCircle('}`', 1,col,ltp,wid, 0.0,50.0,lx1);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpN) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidN) then wid := 1 ;
   end;

   // ~ʃf[^o^eXg
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 10 do begin
      lx1 := i*5 ;
      CData.AddDataArc('', 1,col,ltp,wid,0, 80.0,0.0,lx1,0.0,180.0);
      CData.AddDataArc('}`', 1,col,ltp,wid,1, 80.0,0.0,lx1,0.0,180.0);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpN) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidN) then wid := 1 ;
   end;

   DisplayAllData ;  // Sf[^\

   gp.G_End;
end;

end.
