// Ǝ֐E葱܂Ƃ߂jbg
unit UnitFunc;

interface

uses
   SysUtils, Math ;

const
   LIMIT8  = 0.00000001 ;
   LIMIT10 = 0.0000000001;

type
   TMatrix = record           // ϊs
      t11,t12,t13 : double ;
      t21,t22,t23 : double ;
      t31,t32,t33 : double ;
   end;

procedure SwapI(var a,b:integer);
procedure SwapD(var a,b:double);
function  Roff(V:double) : double ;
function  Dist(x1,y1,x2,y2:double):double ;
function   Angle(dx,dy:double):double ;
function  dAngle(dx,dy:double):double ;
function  SetAngle(a:double) : double ;
procedure  Rev(var rx,ry:double;x,y,cx,cy,a:double) ;
procedure dRev(var rx,ry:double;x,y,cx,cy,a:double) ;
function   RevX(x,y,cx,cy,a:double):double ;
function   RevY(x,y,cx,cy,a:double):double ;
function  SInt(s:string) : integer ;
function  SDbl(s:string) : double ;
function  DStr(V1:double;V2:integer) : string ;
function  MidStr2(S:AnsiString; V1,V2:integer;var V3:integer) : AnsiString ;

procedure MtxClear(var t:TMatrix);
procedure MtxSetE(var t:TMatrix);
procedure MtxSetYX(var t:TMatrix);
procedure MtxSet(var t:TMatrix;a11,a12,a13, a21,a22,a23, a31,a32,a33:double);
procedure MtxMove(var t:TMatrix;dx,dy:double);
procedure MtxScale(var t:TMatrix;sx,sy:double);
procedure MtxRotD(var t:TMatrix;ang:double);
procedure MtxRot(var t:TMatrix;ang:double);
function  MtxAdd(t1,t2:TMatrix) : TMatrix ;
function  MtxMult(t1,t2:TMatrix) : TMatrix ;
procedure MtxXY(var x,y:double;xx,yy:double;t:TMatrix);

implementation

// l葱iŁj
procedure SwapI(var a,b:integer);
var
   c : integer ;
begin
   c := a ;
   a := b ;
   b := c ;
end;

// l葱iŁj
procedure SwapD(var a,b:double);
var
   c : double ;
begin
   c := a ;
   a := b ;
   b := c ;
end;

// 덷ۂ
//    _ȉ11Ŏľܓď_ȉ10ɂ
function Roff(V:double) : double ;
var
	r : double ;
begin
	r := Int(Abs(V)/LIMIT10 + 0.5)*LIMIT10 ;
   if (V < 0.0) then r := -r ;
	Result := r ;
end;

// ijvZ
//@@x1,y1 : n_
//@@x2,y2 : I_
//@@out : ()
function Dist(x1,y1,x2,y2:double):double ;
begin
	Result := Sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1)) ;
end;

// pxvZ[rad]
//@@dx : X
//@@dy : Y
//@@out: px (0`2*Pi)
function Angle(dx,dy:double):double ;
var
   r : double ;
begin
	Result := 0.0 ;
	if (Abs(dx) < LIMIT8)and(Abs(dy) < LIMIT8) then exit ;
	r := ArcTan2(dy,dx);
	if (r < 0.0) then r := r + 2.0 * Pi ;
   Result := r ;
end;

// pxvZ[]
//@@dx : X
//@@dy : Y
//@@out: px (0`360)
function dAngle(dx,dy:double):double ;
var
   r : double ;
begin
	r := Angle(dx,dy)*180.0/Pi ;
   Result := Roff(r) ;     // 덷ۂ߂ĕԂ
end;

// px[]𒲐
//    0 <= a < 360 ɂ
function SetAngle(a:double) : double ;
begin
   while (a <    0.0) do a := a + 360.0;
   while (a >= 360.0) do a := a - 360.0;
   Result := a ;
end;

// ][rad]
//    rx,ry : ]̍W
//    x ,y  : W
//    cx,cy : ]SW
//    a     : ]px[rad]
procedure Rev(var rx,ry:double;x,y,cx,cy,a:double) ;
begin
   rx := cx + (x-cx)*Cos(a) - (y-cy)*Sin(a) ;
   ry := cy + (x-cx)*Sin(a) + (y-cy)*Cos(a) ;
end;

// ][]
//    rx,ry : ]̍W
//    x ,y  : W
//    cx,cy : ]SW
//    a     : ]px[]
procedure dRev(var rx,ry:double;x,y,cx,cy,a:double) ;
var
   an : double ;  // WAl
begin
   an := a/180.0*Pi ;
   Rev(rx,ry, x,y,cx,cy,an) ;
end;

// ]x [rad]
//    x,y   :W
//    cx,cy :]SW
//    a     :]px[rad]
//    out   :]xW
//    ʏ́ARevAdRev 䗘p
function RevX(x,y,cx,cy,a:double):double ;
var
   w : double ;
begin
   w := cx + (x-cx)*Cos(a) - (y-cy)*Sin(a) ;
   Result := w ;
end;

// ]y [rad]
//    x,y   :W
//    cx,cy :]SW
//    a     :]px[rad]
//    out   :]yW
//    ʏ́ARevAdRev 䗘p
function RevY(x,y,cx,cy,a:double):double ;
var
   w : double ;
begin
   w := cy + (x-cx)*Sin(a) + (y-cy)*Cos(a) ;
   Result := w ;
end;



// 𐮐ɕϊ
function SInt(s:string) : integer;
var
   i,j : integer ;
begin
   i := 0 ;
   if (s <> '') then begin
      Val(s,i,j);
      if (j <> 0) then i:=0 ;
   end;
   Result := i ;
end;

// ɕϊ
function SDbl(s:string) : double;
var
   d : double ;
   j : integer ;
begin
   d := 0.0 ;
   if (s <> '') then begin
      Val(s,d,j);
      if (j <> 0) then d:=0.0 ;
   end;
   Result := d ;
end;

{lR}̐lƂĕɕϊ}
{  in : V1 : l}
{       V2 : _ȉ}
function DStr(V1:double;V2:integer) : string ;
var
   s : string ;
begin
   s := '%.' + IntToStr(V2) + 'f' ;
   Result := Format(s,[V1]);
end ;

{ ̎wʒu炎oCgo܂
   in:S  ... ̕
     :V1 ... oJnʒu(1`)
     :V2 ... ooCg
 	out:V3 .. ۂɔooCg
   out: .... o
ŌA̕Ȃ悤ɒ }
function MidStr2(S:AnsiString; V1,V2:integer;var V3:integer) : AnsiString ;
var
   s1,s_1 : AnsiString ;
   i,l : integer ;
   f : Boolean;
begin
   l := Length(S) ;
   if (S = '')or(V1 < 1)or(V1 > l)or(V2 <= 0) then begin
       Result := '' ;
       V3 := 0;
       exit;
   end;
	s1:='';
   V3:=0;
	i:=1;
	f:=True;
	while(f)do begin
      s_1 := Copy(S,i,2) ;
		if (Ord(s_1[1]) >= 128)and(Ord(s_1[1]) <= 159)
       or(Ord(s_1[1]) >= 224)and(Ord(s_1[1]) <= 253) then begin
			if (i >= V1)and(i+1 <= V1+V2-1) then begin
         	// s1:=s1+S[i]+S[i+1];
            s1 := s1 + s_1 ;
         	V3:=V3+2;
         end;
			i:=i+2;
      end
      else begin
			if (i >= V1)and(i <= V1+V2-1) then begin
         	// s1:=s1+S[i];
            s1 := s1 + s_1[1] ;
         	Inc(V3);
         end;
			Inc(i);
      end;
		if (i > l) then f:=False;
   end;
   Result := s1 ;
end;

// ------------------------
// ϊsp̊֐E葱
// ------------------------

// ϊsNAiALL 0j
procedure MtxClear(var t:TMatrix);
begin
   t.t11:=0.0;    t.t12:=0.0;    t.t13:=0.0;
   t.t21:=0.0;    t.t22:=0.0;    t.t23:=0.0;
   t.t31:=0.0;    t.t32:=0.0;    t.t33:=0.0;
end;

// ϊsPʍsɂ
procedure MtxSetE(var t:TMatrix);
begin
   t.t11:=1.0;    t.t12:=0.0;    t.t13:=0.0;
   t.t21:=0.0;    t.t22:=1.0;    t.t23:=0.0;
   t.t31:=0.0;    t.t32:=0.0;    t.t33:=1.0;
end;

// YXXYɒusɂ
procedure MtxSetYX(var t:TMatrix);
begin
   t.t11:=0.0;    t.t12:=1.0;    t.t13:=0.0;
   t.t21:=1.0;    t.t22:=0.0;    t.t23:=0.0;
   t.t31:=0.0;    t.t32:=0.0;    t.t33:=1.0;
end;

// ϊsɔCӂ̒l
procedure MtxSet(var t:TMatrix;a11,a12,a13, a21,a22,a23, a31,a32,a33:double);
begin
   t.t11:=a11;    t.t12:=a12;    t.t13:=a13;
   t.t21:=a21;    t.t22:=a22;    t.t23:=a23;
   t.t31:=a31;    t.t32:=a32;    t.t33:=a33;
end;

// ړp̕ϊs쐬
//    dx : Xړ
//    dy : Yړ
procedure MtxMove(var t:TMatrix;dx,dy:double);
begin
   t.t11:=1.0;    t.t12:=0.0;    t.t13:=0.0;
   t.t21:=0.0;    t.t22:=1.0;    t.t23:=0.0;
   t.t31:=dx ;    t.t32:=dy ;    t.t33:=1.0;
end;

// {p̕ϊs쐬
//    sx : Xړx
//    sy : Yړx
procedure MtxScale(var t:TMatrix;sx,sy:double);
begin
   t.t11:=sx ;    t.t12:=0.0;    t.t13:=0.0;
   t.t21:=0.0;    t.t22:=sy ;    t.t23:=0.0;
   t.t31:=0.0;    t.t32:=0.0;    t.t33:=1.0;
end;

// ]p̕ϊs쐬
//    ang : px[]
procedure MtxRotD(var t:TMatrix;ang:double);
begin
   MtxRot(t,ang/180.0*Pi);
end;

// ]p̕ϊs쐬
//    ang : px[rad]
procedure MtxRot(var t:TMatrix;ang:double);
begin
   t.t11:= cos(ang);    t.t12:=sin(ang);     t.t13:=0.0;
   t.t21:=-sin(ang);    t.t22:=cos(ang);     t.t23:=0.0;
   t.t31:=0.0;          t.t32:=0.0;          t.t33:=1.0;
end;

// ϊs̑Z
function MtxAdd(t1,t2:TMatrix) : TMatrix ;
var
   r : TMatrix ;
begin
   r.t11 := t1.t11 + t2.t11 ;
   r.t12 := t1.t12 + t2.t12 ;
   r.t13 := t1.t13 + t2.t13 ;
   r.t21 := t1.t21 + t2.t21 ;
   r.t22 := t1.t22 + t2.t22 ;
   r.t23 := t1.t23 + t2.t23 ;
   r.t31 := t1.t31 + t2.t31 ;
   r.t32 := t1.t32 + t2.t32 ;
   r.t33 := t1.t33 + t2.t33 ;
   Result := r ;
end;

// ϊs̊|Z
function  MtxMult(t1,t2:TMatrix) : TMatrix ;
var
   r : TMatrix ;
begin
   r.t11 := t1.t11*t2.t11 + t1.t12*t2.t21 + t1.t13*t2.t31 ;
   r.t12 := t1.t11*t2.t12 + t1.t12*t2.t22 + t1.t13*t2.t32 ;
   r.t13 := t1.t11*t2.t13 + t1.t12*t2.t23 + t1.t13*t2.t33 ;
   r.t21 := t1.t21*t2.t11 + t1.t22*t2.t21 + t1.t23*t2.t31 ;
   r.t22 := t1.t21*t2.t12 + t1.t22*t2.t22 + t1.t23*t2.t32 ;
   r.t23 := t1.t21*t2.t13 + t1.t22*t2.t23 + t1.t23*t2.t33 ;
   r.t31 := t1.t31*t2.t11 + t1.t32*t2.t21 + t1.t33*t2.t31 ;
   r.t32 := t1.t31*t2.t12 + t1.t32*t2.t22 + t1.t33*t2.t32 ;
   r.t33 := t1.t31*t2.t13 + t1.t32*t2.t23 + t1.t33*t2.t33 ;
   Result := r ;
end;

// Wϊ
//    x,y   : ʂX,YW
//    xx,yy : ϊX,YW
//    t     : ϊs
procedure MtxXY(var x,y:double;xx,yy:double;t:TMatrix);
begin
   x := t.t11*xx + t.t21*yy + t.t31 ;
   y := t.t12*xx + t.t22*yy + t.t32 ;
end;

end.
